/*
 MIT License http://www.opensource.org/licenses/mit-license.php
 Author Eisi Sig @eisisig
 */
var docgen = require('react-docgen');
var findAllComponentDefinitions = require('react-docgen/dist/resolver/findAllComponentDefinitions');
var marked = require('marked');
var colors = require('colors');
var loaderUtils = require('loader-utils');

module.exports = function ( source ) {

	this.cacheable && this.cacheable();
	var query = loaderUtils.parseQuery(this.query);

	var value = {};

	try {
		value = docgen.parse(source, findAllComponentDefinitions);
		if ( query.markdownDescription && value.description ) {
			value.description = marked(value.description);
		}
	} catch ( e ) {
		console.log('docgen-loader'.red,  e);
	}

	this.values = [value];
	return "module.exports = " + JSON.stringify(value, undefined, "\t");
};
